
/* Chrysalide - Outil d'analyse de fichiers binaires
 * debugger.h - prototypes pour le débogage d'une cible en Java.
 *
 * Copyright (C) 2010-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DEBUG_JDWP_DEBUGGER_H
#define _DEBUG_JDWP_DEBUGGER_H


#include <glib-object.h>


#include "../debugger.h"



#define G_TYPE_JAVA_DEBUGGER            (g_java_debugger_get_type())
#define G_JAVA_DEBUGGER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_JAVA_DEBUGGER, GJavaDebugger))
#define G_IS_JAVA_DEBUGGER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_JAVA_DEBUGGER))
#define G_JAVA_DEBUGGER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_JAVA_DEBUGGER, GJavaDebuggerClass))
#define G_IS_JAVA_DEBUGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_JAVA_DEBUGGER))
#define G_JAVA_DEBUGGER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_JAVA_DEBUGGER, GJavaDebuggerClass))


/* Débogueur utilisant un serveur Java (instance) */
typedef struct _GJavaDebugger GJavaDebugger;

/* Débogueur utilisant un serveur Java (classe) */
typedef struct _GJavaDebuggerClass GJavaDebuggerClass;


/* Indique le type défini par la GLib pour le débogueur Java. */
GType g_java_debugger_get_type(void);

/* Crée un débogueur utilisant un serveur Java distant. */
GBinaryDebugger *g_java_debugger_new(GLoadedBinary *, void *);


void test_java(void);



#endif  /* _DEBUG_JDWP_DEBUGGER_H */
