
/* Chrysalide - Outil d'analyse de fichiers binaires
 * glinecursor-int.h - définitions internes propres au suivi de positions
 *
 * Copyright (C) 2018 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GLIBEXT_GLINECURSOR_INT_H
#define _GLIBEXT_GLINECURSOR_INT_H


#include "glinecursor.h"



/* Compare deux suivis d'emplacements. */
typedef int (* compare_cursor_fc) (const GLineCursor *, const GLineCursor *);

/* Détermine si un suivi d'emplacement est valide ou non. */
typedef bool (* is_cursor_valid_fc) (const GLineCursor *);


/* Suivi de positions dans un panneau de chargement (instance) */
struct _GLineCursor
{
    GObject parent;                         /* A laisser en premier        */

};

/* Suivi de positions dans un panneau de chargement (classe) */
struct _GLineCursorClass
{
    GObjectClass parent;                    /* A laisser en premier        */

    compare_cursor_fc compare;              /* Comparaison d'emplacements  */
    is_cursor_valid_fc is_valid;            /* Certificat de validité      */

};



#endif  /* _GLIBEXT_GLINECURSOR_INT_H */
