
/* Chrysalide - Outil d'analyse de fichiers binaires
 * glinecursor.h - prototypes pour le suivi de positions dans des panneaux de chargement
 *
 * Copyright (C) 2018 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GLIBEXT_LINECURSOR_H
#define _GLIBEXT_LINECURSOR_H


#include <glib-object.h>
#include <stdbool.h>



#define G_TYPE_LINE_CURSOR            (g_line_cursor_get_type())
#define G_LINE_CURSOR(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_LINE_CURSOR, GLineCursor))
#define G_LINE_CURSOR_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_LINE_CURSOR, GLineCursorClass))
#define G_IS_LINE_CURSOR(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_LINE_CURSOR))
#define G_IS_LINE_CURSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_LINE_CURSOR))
#define G_LINE_CURSOR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_LINE_CURSOR, GLineCursorClass))


/* Suivi de positions dans un panneau de chargement (instance) */
typedef struct _GLineCursor GLineCursor;

/* Suivi de positions dans un panneau de chargement (classe) */
typedef struct _GLineCursorClass GLineCursorClass;


/* Détermine le type du suivi de positions dans un panneau de chargement. */
GType g_line_cursor_get_type(void);

/* Compare deux suivis d'emplacements. */
int g_line_cursor_compare(const GLineCursor *, const GLineCursor *);

/* Détermine si un suivi d'emplacement est valide ou non. */
bool g_line_cursor_is_valid(const GLineCursor *);



#endif  /* _GLIBEXT_LINECURSOR_H */
